#!/usr/bin/perl -w

#
# Super Simple QueueServer for SMS-Link
# Richard.Prinz@MIN.at 18.3.2003
#
# refreshes the sms counters for each
# sms user once a month
#

use strict;
use diagnostics;

# Name the global variables
my @lines = ();
my ($UserID, %UserID);
my ($CurCount, %CurCount);
my ($MaxCount, %MaxCount);
my $dCurCount = 0;
my $dMaxCount = 5;
my ($key, $value);
my $i;
my $Cur = 0;
my $Max = 0;



# ----- change these path to fit your needs -----
my $countfile = "/etc/gsmcounters";
my $countback = "/etc/gsmcounters.bak";
# -----------------------------------------------



open(INDAT,"<$countfile") or die("Cannot read file <$countfile>: $!\n");
flock(INDAT, 2); # exclusive lock
seek(INDAT, 0, 0);
chomp(@lines=<INDAT>); 
rename($countfile,$countback);

foreach $i (@lines) {
 ($UserID, $CurCount, $MaxCount)=split(/:/,$i);
 $UserID{lc($UserID)}=lc($UserID);
 $CurCount{lc($UserID)}=uc($CurCount);
 $MaxCount{lc($UserID)}=uc($MaxCount);
}

if ($UserID{"default"} eq "") {
 $UserID{"default"}="default";
 $CurCount{"default"}=5;
 $MaxCount{"default"}=5;
}
 
$dCurCount=$CurCount{"default"};
$dMaxCount=$MaxCount{"default"};

open(OUTDAT,">$countfile") or die("Cannot write file <$countfile>: $!\n");
flock(OUTDAT, 2); # exclusive lock
seek(OUTDAT, 0, 0);

@lines=();
while(($key, $value) = each(%UserID)) {
 if($value ne "") {
 
  if($MaxCount{$value} eq "") {
   $MaxCount{$value} = "D";
  }
  
  if($CurCount{$value} ne "U") {
   $Max = $MaxCount{$value};
   if($Max eq "D") {
     $Max = $dMaxCount;
   }
   $CurCount{$value} = $Max;
  }
  
  #print OUTDAT "$UserID{$value}:$CurCount{$value}:$MaxCount{$value}\n";
  push(@lines,"$UserID{$value}:$CurCount{$value}:$MaxCount{$value}\n");
 }
}
@lines=sort(@lines);
print OUTDAT @lines;

flock(OUTDAT, 8); # remove lock
close(OUTDAT);
chmod(0666, $countfile);
 
flock(INDAT, 8); # remove lock
close(INDAT);


