#!/usr/bin/perl

#
# Super Simple QueueDaemon for SMS-Link
# Richard.Prinz@MIN.at 18.3.2003
#

use strict;
use diagnostics;
use Socket;

my $userid = "";
my $network = "";
my $dest = "";
my $msgtxt = "";
my $retmail = "";



# ----- change these path to fit your needs -----
my $accessfile = "/etc/gsmaccess";
my $countfile = "/etc/gsmcounters";
my $queuepath = "/usr/local/apache/cgi-bin/smsqueue";
# -----------------------------------------------



my ($UserID, %UserID);
my ($CurCount, %CurCount);
my ($MaxCount, %MaxCount);

my $risnet = " - via WebMail.RISNet.at";

my $rtc = 0;
my $elapsed;
my ($sec, $min, $hr, $day, $mon, $yr, $wk, $jul, $dls) = localtime(time);
my $lt = sprintf("%04d%02d%02d:%02d%02d%02d",$yr+1900,$mon+1,$day,$hr,$min,$sec);

#print %ENV;
#print @ARGV;

# show server greeting
print "\n";
print "SMS-Link QueueServer V1.5\n";
print "(c) Richard.Prinz\@MIN.at 2003\n";
my $hersockaddr = getpeername(STDIN);
if (defined($hersockaddr)) {
 my ($port, $iaddr) = sockaddr_in($hersockaddr);
 my $herhostname = gethostbyaddr($iaddr, AF_INET);
 if (!defined($herhostname)) {
  $herhostname = "unknown";
 }
 my $herstraddr = inet_ntoa($iaddr); 
 print "Connect from $herhostname ($herstraddr:$port)\n\n";
    
 # if not a local connect - check ip adress from the client
 # against the gsmaccess file and see if the client is
 # allowed to send sms messages
 my @alines = ();
 my $ai;
 my $allowed = 0;
 my ($access,$anet,$amask);
 my ($subnetmask, $network, $host, $broadcast);

 open(DAT,"$accessfile") or dienice("Cannot read file <$accessfile>: $!\n");
 flock(DAT, 1); # read lock
 chomp(@alines=<DAT>);
 #@lines=<DAT>;
 flock(DAT, 8); # remove lock
 close (DAT);
 #If speed is critical, do the chomp after the close. It's pretty memory intensive.
 #chomp @lines;
 
 # try to find a match with an entry in the allowed ip's file
 # NOTE: a (N)o for a matched IP address takes precedence over a (Y)es match. this
 # means a client can not connect when ther is a match with a (n) in the first
 # collumn - even if there are other matches with (y) !!!
 foreach $ai (@alines) {
  ($access, $anet, $amask) = split(/[:\/]/,$ai);
  if (!defined($amask)) {
   $amask = 32;
  }
  if (defined($access) && defined($anet)) {
   $access = uc($access);
   if ($access !~ m/^\#.*/ && $anet !~ m/^\#.*/ && $amask !~ m/^\#.*/) {
    if ($amask eq "") {
     $amask = 32;
    }
    ($subnetmask, $network, $host, $broadcast) = &ip2subnet_net_host_broadcast($anet, $amask);
    #print "$access $anet $amask ($subnetmask) ($network) ($host) ($broadcast)\n";
    if ( ($herstraddr eq $network && $herstraddr eq $broadcast) ||
         ($herstraddr gt $network && $herstraddr lt $broadcast) ) {
     if ($access eq "Y") {
      #print "******* ALLOWED *******\n";
      $allowed = 1;
     }
     else {
      #print "******* NOT ALLOWED *******\n";
      $allowed = 0;
      last;
     }
    }
   }
  }
 }
    
 if (!$allowed) {
  print "ERROR: You are not allowed to send SMS messages!\n";
  exit;
 }        
}
else {
 print "Local connect\n\n";
}

my $msg = "";
my $line = 0;

# server dialog
 print "SMS> \n";
 while(<STDIN>) {
  #print $_;
  chomp;
  s/[\n\r\t]//g;
  print "SMS> Ok (".$_.")\n";
  print "SMS> \n";
  if ($_ eq "") {
   next;
  }
  $line++;
  if ($_ eq ".") {
   last;
  }
  $msg = $msg . $_ . "\n";
  if (length($msg) > 255) {
   last;
  }
  if ($line >= 10) {
   last;
  }
 }

($userid, $dest, $msgtxt, $retmail)=split(/\n/,$msg);
if(!defined($userid)) { $userid = "" };
if(!defined($dest)) { $dest = "" };
if(!defined($msgtxt)) { $msgtxt = "" };
if(!defined($retmail)) { $retmail = "" };

# where all needed fields filled ?
if (($userid eq "") || ($dest eq "") || ($msgtxt eq "")) {
 print "ERROR: You filled not in all fields!\n";
 exit;
}

$msgtxt = substr($msgtxt,0,134) . $risnet;
# Check message length
#if (length($msgtxt) > 160) {
# print "ERROR: Your message is longer than 160 chars!\n";
# exit;
#}
  
# Remove newlines and tabs from msgtxt (replace them by space)
$msgtxt =~ s/\n/ /g;
$msgtxt =~ s/\t/ /g;

# read counters database
&ReadCounters();

# write sms to sms queue for later sending
$elapsed = time();
my $fn=time()."-".int(rand(10)).".smsq";
$rtc = &WriteQueue("$queuepath/$fn");  
$elapsed = time() - $elapsed;

if ($rtc == 1) {

 # log sms
 if ($msgtxt !~ m/^\-.*/) {
  if (open(OUT,">>$queuepath/log/queue.log")) {
   print OUT "$lt:$userid:$dest:$retmail:QS:$msgtxt\n";
   close(OUT);
  }
 }

 # decrease counter
 if ($CurCount{$userid} ne "U") {
  $CurCount{$userid}--;
  &WriteCounters();
 }
}
else {
 print "ERROR: Faild to queue message!\n";
}

exit(0);

#-----------------------------------------------------------

sub WriteQueue() {
 my ($filename) = @_;

 if (open(OUT,">$filename")) {
  print OUT $userid."\n";
  print OUT $dest."\n";
  print OUT $msgtxt."\n";
  print OUT $retmail."\n";
  close(OUT);
  return 1;
 }
 else {
  return 0;
 }
}

#-----------------------------------------------------------

sub ReadCounters {
 my @lines = ();
 my $i;

 open(DAT,"$countfile") or dienice("Cannot read file <$countfile>: $!\n");
 flock(DAT, 1); # read lock
 chomp(@lines=<DAT>);
 #@lines=<DAT>;
 flock(DAT, 8); # remove lock
 close (DAT);
 #If speed is critical, do the chomp after the close. It's pretty memory intensive.
 #chomp @lines;
 foreach $i (@lines) {
  ($UserID, $CurCount, $MaxCount)=split(/:/,$i);
  $UserID{lc($UserID)}=lc($UserID);
  $CurCount{lc($UserID)}=uc($CurCount);
  $MaxCount{lc($UserID)}=uc($MaxCount);
 }
 if ($MaxCount{$userid} eq "") {
  if ($UserID{"default"} ne "" && $MaxCount{"default"} ne "") {
   #$MaxCount{$userid}=$MaxCount{"default"};
   $MaxCount{$userid}="D";
  }
  else {
   $MaxCount{$userid}=0;
  }
 }
 if ($CurCount{$userid} ne "U") {
  if ($UserID{$userid} eq "" || $CurCount{$userid} <= 0) {
   print "Error: You are either not allowed to send or you have reached your SMS limit\n";
   exit;
  }
 }
}

#-----------------------------------------------------------

sub WriteCounters {
 my ($key, $value);
 
 open(DAT,">$countfile") or dienice("Cannot write file <$countfile>: $!\n");
 flock(DAT, 2); # write lock
 seek(DAT, 0, 0);
 while(($key, $value) = each(%UserID)) {
  if ($value ne "") {
   print DAT "$UserID{$value}:$CurCount{$value}:$MaxCount{$value}\n";
  }
 }
 flock(DAT, 8); # remove lock
 close (DAT);
}

#-----------------------------------------------------------

# converts decimal dotted quad string to network ordered long
sub dottedquad2long {
 return unpack('N', inet_aton(shift));
#  or
#  return unpack 'N', pack 'C4', split /\./, shift;
#  or
#  my @seg = split(/\./, shift);
#  return $seg[0]*256**3+$seg[1]*256**2+$seg[2]*256+$seg[3];
}
  
#-----------------------------------------------------------

# converts network ordered long to dotted quad string
sub long2dottedquad {
 return inet_ntoa(pack('N', shift));
}
    
#-----------------------------------------------------------

# converts 32bit binary to network ordered long
sub bin2long {
 return unpack('N', pack('B32', shift));
}
      
#-----------------------------------------------------------

# returns netmask as network ordered long
sub makemask {
 my $mask_length = shift;
 my $binary = '1' x $mask_length . '0' x (32 - $mask_length);
 return bin2long($binary);
}

#-----------------------------------------------------------

# returns broadcast address as network ordered long
sub makebroadcast {
 my ($mask_length, $long_network) = @_;
 my $binary = '0' x $mask_length . '1' x (32 - $mask_length);
 return $long_network | bin2long($binary);
}

#-----------------------------------------------------------

# returns subnet mask, network number, host part, and broadcast address
sub ip2subnet_net_host_broadcast {
 my ($ip, $mask_length) = @_;
 my $long_ip = dottedquad2long($ip);
 my $long_mask = makemask($mask_length);
 my $long_network = $long_ip & $long_mask;
 my $long_host = $long_ip - $long_network;
 my $long_broadcast = makebroadcast($mask_length, $long_network);
 return long2dottedquad($long_mask), long2dottedquad($long_network), 
        long2dottedquad($long_host), long2dottedquad($long_broadcast);
}

